#line 1/*CED 3 0056 */
#ifndef _WINDOWS_
#define _WINDOWS_

/*** Diese Struktur wird fuer w_open() & wl_open() benoetigt ***/
typedef struct _w_desc {      /* BESCHREIBUNG EINES FENSTERS:  */
   int  flags;                /* Fenster-Elemente              */
   int  size[4];              /* aktuelle Groesse              */
   int  max_size[4];          /* max. Groesse                  */
   char *name;                /* Titel-Zeile                   */
   char *info;                /* Info-Zeile                    */
} W_DESC;


typedef struct _wl_lin {      /* EINE FENSTER-ZEILE:           */
   long           attr;       /* Attribute der Zeile           */
   char           *line;      /* Inhalt der Zeile              */
   struct _wl_lin *next;      /* naechste Zeile                */
   struct _wl_lin *prev;      /* vorige Zeile                  */
   char           *user;      /* frei verfuegbares Feld        */
} wl_lin;

#define WL_BOLD         1     /* Zeile in Fett-Schrift         */
#define WL_DISABLED     2     /* Zeile hell dargestellt        */
#define WL_ITALICS      4     /* Zeile kursiv                  */
#define WL_UNDERLINED   8     /* Zeile unterstrichen           */
#define WL_OUTLINED     16    /* Zeile innen hohl & umrandet   */
#define WL_SHADOWED     32    /* Zeile schattiert              */
#define WL_SELECTED     64    /* Zeile wird invertiert         */
#define WL_CHECKED      128   /* Zeile wird abgehakt           */


typedef struct _wl_ptr {      /* FENSTER-INHALT:                     */
   int    handle;             /* Handle des zugehoerigen Fensters    */
   int    firstlin;           /* Nummer der ersten Zeile im Fenster  */
   int    firstcol;           /* Nummer der ersten Spalte im Fenster */
   int    anzlin;             /* Anzahl der Zeilen in der Liste      */
   int    anzcol;             /* Max. Anzahl Zeichen pro Zeile       */
   int    flags;              /* Attribute des Fensters              */
   wl_lin *ptr;               /* -> auf Liste mit Text               */
} wl_ptr;

#define WL_ISLST     1        /* => Fensterliste ist gueltig               */
#define WL_TMPLST    2        /* => bei wl_close() Liste loeschen          */
#define WL_VSLID     4        /* => F. hat vert. Slider (wg. GEM-Fehler)   */
#define WL_HSLID     8        /* => F. hat hor. Slider (wg. GEM-Fehler)    */
#define WL_USRPTR    16       /* => <user>-Feld ist Pointer                */


wl_ptr wl_arr[7];             /* Fuer alle Fenster */

extern wl_lin *wl_elem(),
              *wl_agetlin(), *wl_rgetlin(),
              *wl_afirst(),  *wl_anext(),
              *wl_headnew(), *wl_tailnew(),
              *wl_pnew(),    *wl_snew();

#endif _WINDOWS_
